var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import getDerivedState from './get-derived-state';
import { toPairs, typeOf } from './util';

var embedSelectors = function embedSelectors(selectors) {
  if (typeOf(selectors) !== 'object') {
    throw new TypeError('Expected `selectors` to be an object. ' + ('`selectors` is type ' + typeOf(selectors) + ' instead.'));
  }

  var selectorPairs = toPairs(selectors);

  return function (next) {
    return function (reducer, preloadedState) {
      var store = next(reducer, preloadedState);

      return _extends({}, store, {
        getState: function getState() {
          var state = store.getState();

          return _extends({}, state, getDerivedState(selectorPairs, state));
        }
      });
    };
  };
};

export default embedSelectors;