'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getDerivedState = require('./get-derived-state');

var _getDerivedState2 = _interopRequireDefault(_getDerivedState);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var embedSelectors = function embedSelectors(selectors) {
  if ((0, _util.typeOf)(selectors) !== 'object') {
    throw new TypeError('Expected `selectors` to be an object. ' + ('`selectors` is type ' + (0, _util.typeOf)(selectors) + ' instead.'));
  }

  var selectorPairs = (0, _util.toPairs)(selectors);

  return function (next) {
    return function (reducer, preloadedState) {
      var store = next(reducer, preloadedState);

      return _extends({}, store, {
        getState: function getState() {
          var state = store.getState();

          return _extends({}, state, (0, _getDerivedState2.default)(selectorPairs, state));
        }
      });
    };
  };
};

exports.default = embedSelectors;